//------------------------------------------------------------------------
//        "" 
//
//  Arsen:   03.2005,
//         -   LED  PD6     
//         -  5    ,  LED 5 
//         -  LED      
//         -      LED  
//         -     
//         -  ""   
//
//  Arsen:   20.04.2006,
//         -      WinAVR
//         -  WinAVR v3.4.5,  20060125
//
//  :
//    () RodoClub.ru 2003
//------------------------------------------------------------------------

#include <inttypes.h>
#include <avr/io.h>
#include <compat/deprecated.h>
#include <avr/interrupt.h>

#define outb(SFR, value) //     

//     
#define OUT PORTB
#define MOTOR_FR  PB7  // -
#define MOTOR_BR  PB6  // -
#define MOTOR_BL   PB5  // -
#define MOTOR_FL   PB4  // -

#define IN PIND
#define LIGHT_R  PD0
#define LIGHT_L  PD1
#define BUMPER_F PD2
#define BUMPER_B PD3
#define LED PD6


//      
// R, L -     , 

enum {STOP, F, FR, FL, B, BR, BL, R, L};

//------------------------------------------------------------------------------
//  t  10ms
//------------------------------------------------------------------------------
//#define F_CPU 4000000
#define K_DELAY_10ms	F_CPU/600
void Delay_10ms(unsigned char t) {
  if (t==0) return;
  unsigned int i;
  while (t--) for(i=0;i<K_DELAY_10ms; i++);
}

//      , 
//    .    
// STOP, F, FR, FL, B, BR, BL, R, L -     
unsigned char p[9][9] = {
{21,52,52,52,52,52,52,76,100},
{7,43,71,100,100,100,100,100,100},
{7,50,93,100,100,100,100,100,100},
{7,50,57,100,100,100,100,100,100},
{29,29,29,29,56,78,100,100,100},
{36,36,36,36,71,93,100,100,100},
{36,36,36,36,71,78,100,100,100},
{15,40,50,55,55,55,55,85,100},
{15,40,45,55,55,55,55,70,100},
};
//   
unsigned char this_move; 

//------------------------------------------------------------------------------
//        
//    ,    !
//------------------------------------------------------------------------------
void go(unsigned char direction){

  switch (direction) {
  case STOP:
    cbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case F:
    sbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    sbi(OUT, MOTOR_FL);
    break;

  case FR:
    cbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    sbi(OUT, MOTOR_FL);
    break;

  case FL:
    sbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case B:
    cbi(OUT, MOTOR_FR);
    sbi(OUT, MOTOR_BR);
    sbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case BR:
    cbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    sbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case BL:
    cbi(OUT, MOTOR_FR);
    sbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case R:
    cbi(OUT, MOTOR_FR);
    sbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    sbi(OUT, MOTOR_FL);
    break;

  case L:
    sbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    sbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;
  }
}

//------------------------------------------------------------------------------
//         
//------------------------------------------------------------------------------
unsigned char next_move(void){
   unsigned char pp, i;

   pp = rand()/327;     //    0..99
   for (i=0;i<9;i++){   //     
      if (p[this_move][i] > pp) break;
   }
   this_move = i;       //      
   return(i);
}

//------------------------------------------------------------------------------
//      (INT0 = PD2)
//------------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT0)
{
   if(this_move==FR) go(BL);
   if(this_move==FL) go(BR);
   else go(B);

//      

   cbi(PORTD, LED); // 
   Delay_10ms(250);    //    2.5  2 
   Delay_10ms(250);
   sbi(PORTD, LED); // 

//  

   this_move=B;
}

//------------------------------------------------------------------------------
//      (INT1 = PD3)
//------------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT1)
{
   if(this_move==BR) go(FL);
   if(this_move==BL) go(FR);
   else go(F);

//      

   cbi(PORTD, LED); // 
   Delay_10ms(250);    //    2.5  2 
   Delay_10ms(250);
   sbi(PORTD, LED); // 

//  

   this_move=F;
}

//------------------------------------------------------------------------------
// " "
//------------------------------------------------------------------------------
unsigned char walk(void){
   //    " " 
   //        
   while((bit_is_set(IN, LIGHT_R)) && (bit_is_set(IN, LIGHT_L))){
       go(next_move());   //     

//        

       cbi(PORTD, LED); //    PD4
       Delay_10ms(125);   //     2.5 
       sbi(PORTD, LED); //    PD4
       Delay_10ms(125);   //     2.5 
   }
   //      , 
   //         
   while((bit_is_clear(IN, LIGHT_R)) || (bit_is_clear(IN, LIGHT_L))){
       if((bit_is_clear(IN, LIGHT_R)) && (bit_is_clear(IN, LIGHT_L))) go(F);
       else if(bit_is_clear(IN, LIGHT_R)) go(FR);
       else if(bit_is_clear(IN, LIGHT_L)) go(FL);
   }

   return(0);
}

//------------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------
int main(void)
{
  DDRB  = 0xff;  //     B  
  PORTB = 0x00;  //      

  DDRD  = 0x40;  //     D  ,  PD6
  PORTD = 0xbf;  //    ,  PD6


  //   int0  int1
  outb(GIMSK, (1<<INT0)|(1<<INT1)); 

  //    -     int0  int1
  outb(MCUCR, (1<<ISC01)|(1<<ISC11));

  //  
  sei();          

//     5 
//       :)

  //      
  unsigned char i;

  for (i=0;i<5;i++){   //   
    cbi(PORTD, LED); //  LED
    Delay_10ms(250);  // 
    sbi(PORTD, LED); //  LED
    Delay_10ms(250);  // 
    }

  //   
  while(1) walk();

}

