//******************************************************************************
// http://ironfelix.ru  Conqeror ()
//   7-  (7-LED),
//        470 
//
//  Arsen: 7.05.2006,
//         -  5    , 
//            LED,    7-LED
//         -  LED      
//         -   
//  
//         -       GCC
//              WinAVR v 3.4.5,  20060125
//******************************************************************************

#include <avr/io.h>
#include <util/delay.h>

//     7-LED
//    2- ,    
//   ,   .
//
//       7-LED 
//           "1"   
//
//     +--A2--+     +--A1--+
//     |      |     |      |
//     F2     B2    F1     B1
//     |      |     |      |
//     +--G2--+     +--G1--+
//     |      |     |      |
//     E2     C2    E1     C1
//     |      |     |      |
//     +--D2--+     +--D1--+
//

//     
//    

//     7-LED
#define A1  (PORTD &= ~(1<<5))  //   7-LED,  D5
#define B1  (PORTD &= ~(1<<1))  //   7-LED,  D1
#define C1  (PORTD &= ~(1<<4))  //   7-LED,  D4
#define D1  (PORTD &= ~(1<<2))  //   7-LED,  D2
#define E1  (PORTB &= ~(1<<4))  //   7-LED,  B4
#define F1  (PORTD &= ~(1<<0))  //   7-LED,  D0
#define G1  (PORTD &= ~(1<<3))  //   7-LED,  D3

//     7-LED
#define _A1  (PORTD |= (1<<5))  //   7-LED,  PD5
#define _B1  (PORTD |= (1<<1))  //   7-LED,  PD1
#define _C1  (PORTD |= (1<<4))  //   7-LED,  PD4
#define _D1  (PORTD |= (1<<2))  //   7-LED,  PD2
#define _E1  (PORTB |= (1<<4))  //   7-LED,  PB4
#define _F1  (PORTD |= (1<<0))  //   7-LED,  PD0
#define _G1  (PORTD |= (1<<3))  //   7-LED,  PB3


//     7-LED
#define A2  (PORTB &= ~(1<<5))  //   7-LED,  PB5
#define B2  (PORTB &= ~(1<<7))  //   7-LED,  PB7
#define C2  (PORTB &= ~(1<<2))  //   7-LED,  PB2
#define D2  (PORTB &= ~(1<<0))  //   7-LED,  PB0
#define E2  (PORTB &= ~(1<<6))  //   7-LED,  PB6
#define F2  (PORTB &= ~(1<<3))  //    ! :(   7-LED,  PB3
#define G2  (PORTB &= ~(1<<1))  //   7-LED,  PB1

//     7-LED
#define _A2  (PORTB |= (1<<5))  //   7-LED,  PB5
#define _B2  (PORTB |= (1<<7))  //   7-LED,  PB7
#define _C2  (PORTB |= (1<<2))  //   7-LED,  PB2
#define _D2  (PORTB |= (1<<0))  //   7-LED,  PB0
#define _E2  (PORTB |= (1<<6))  //   7-LED,  PB6
#define _F2  (PORTB |= (1<<3))  //  ! :(   7-LED,  PB3
#define _G2  (PORTB |= (1<<1))  //   7-LED,  PB1


#define LED_ON PORTD &= ~(1<<6) //  
#define LED_OFF PORTD |= (1<<6) //  


//******************************************************************************
//      
//******************************************************************************

void _LED (void);
void Delay_50ms(unsigned char);
void Delay_Go(unsigned char);
void Print_LED(unsigned char, unsigned char);
void Clear_LED(void);
void Blink_LED(void); 


//******************************************************************************
//   LED
//******************************************************************************
void _LED (void)
{
    LED_ON; //  LED
    Delay_50ms(5);  //  250 ms
    LED_OFF; //  LED
	Delay_50ms(15);  //  750 ms   _LED  1 .
}



//      
//      14- 
//   :     .

enum {r, F, _ALL, _NONE, _TOO, _SKOB};

//******************************************************************************
//    t x 50 ms
//   t=200  == 1 .
//******************************************************************************
void Delay_50ms(unsigned char t) {
  unsigned int i;
  for(i=0;i<t; i++) {
  _delay_ms(50);
  }
}

//******************************************************************************
// ,  0.1   
//       
//******************************************************************************

void Delay_Go(unsigned char t) {
  unsigned int i;
  for (i=0;i<t;i++){
//       cbi(PORTD, LED); 	//   
       Delay_50ms(100);   	//   0.5 
//       sbi(PORTD, LED); 	//   
       Delay_50ms(100);   	//   0.5 
        }
}



//******************************************************************************
//      
//     
//******************************************************************************
void Print_LED(unsigned char Letter2, unsigned char Letter1){

  switch (Letter1) {
  case F:
	_A1; _B1; _C1; _D1; _E1; _F1; _G1; //   
    A1; E1; F1; G1; //     PD
    break;

  case _ALL:
	A1; B1; C1; D1; E1; F1; G1; //   
    break;

  case _NONE:
	_A1; _B1; _C1; _D1; _E1; _F1; _G1; //   
    break;

  case _SKOB:
	_A1; _B1; _C1; _D1; _E1; _F1; _G1; //   
	A1; B1; C1; D1;; //   
    break;
  }

  switch (Letter2) {
  case r:
	_A2; _B2; _C2; _D2; _E2; _F2; _G2; //   
    E2; G2; //     PB
    break;

  case _ALL:
	A2; B2; C2; D2; E2; F2; G2; //   
    break;

  case _NONE:
	_A2; _B2; _C2; _D2; _E2; _F2; _G2; //   
    break;

  case _TOO:
	_A2; _B2; _C2; _D2; _E2; _F2; _G2; //   
    A2; D2; //   
break;
  }
}

//******************************************************************************
//    7-LED
//******************************************************************************
void Clear_LED() {
//    
	
//  PORTB = 0xff;  
//  PORTD = 0xff;  
//    F1 B1 D1 G1 C1 A1 -   
// B2 E2 A2 E1 F2 C2 G2 D2

//	PORTD |= (F1 + B1 + D1 + G1 + C1 + A1); //     PD
//    PORTB |= (B2 + E2 + A2 + E1 + F2 + C2 + G2 + D2); // a    PB
	_A1; _B1; _C1; _D1; _E1; _F1; _G1;
	_A2; _B2; _C2; _D2; _E2; _F2; _G2;
	

}

//******************************************************************************
//     5 
//******************************************************************************


void Blink_LED() {
  //      
  unsigned char i;
  for (i=0;i<5;i++){   //   
    _LED(); //  LED
    }
}

//******************************************************************************
//   
//******************************************************************************
int main(void)
{
  DDRB  = 0xff;  //     PB  
  PORTB = 0xff;  //       -  

  DDRD  = 0xff;  //     PD  
  PORTD = 0xff;  //       -  


	Print_LED(_ALL, _ALL); //   

//	A1; B1; C1; D1; E1; F1; G1; //    
//	A2; B2; C2; D2; E2; F2; G2; //    7-LED


	Blink_LED(); //  


	Print_LED(_NONE, _NONE);  //   
	
//	Clear_LED();   //    ,     

	Blink_LED(); //   

//******************************************************************************
//  
//******************************************************************************
	Print_LED(r, F); //   IrF
	Blink_LED();
	Blink_LED();

	Print_LED(_TOO, _SKOB); //     
	Blink_LED();

	Clear_LED();
	
}


